function psv_message(data, string, handles)
     if nargin ~= 3; return; end;
     log_max_messages = 10; % default log size

    if (isstruct(handles))
        display('warning: psv_message() somebody is using handles');
        replace = 0;
    else
        replace = handles;
    end
    input = get(data.psv_hnames.message_log_handle,'String');
    
    if (isempty(input) || (length(input) ~= log_max_messages ) )
        input = cell( log_max_messages,1 );  % set log size
        for i=1 : log_max_messages
            input{i} = ' ';
        end        
    end

    messageLength = length(input);
    output        = cell(messageLength,1);
    output{1}     = string;
    if (replace == 1)
        for i=2 : messageLength
            output{i} = input{i};
        end        
    else
        for i=1 : messageLength-1
            output{i+1} = input{i};
        end
    end
    set(data.psv_hnames.message_log_handle,'String',output);
    drawnow;
end
