%------------ Set up for phase space plot
%--------------------------------------------------------------------------
function [ data ] = psv_plot_ps(data, new_axes)
    if nargin < 2 || isempty( data ); return; end;

    if ~ isfield(data.ps(data.my_axes),'phasespace')
        psv_message(data, 'There is no data to display, specify an input file first!');
        return
    end
    if new_axes ~= 0
        data.my_axes = new_axes;
    end
    % set frame and coordinate axes
    axes(data.psv_hnames.axes_handles(data.my_axes));
    % horizontal and vertical axis
    hor_axis = data.ps(data.my_axes).hor_axis;
    ver_axis = data.ps(data.my_axes).ver_axis;
    mesh     = get(data.psv_hnames.mesh_handles(data.my_axes), 'Value');  % mesh plot
    fix      = get(data.psv_hnames.square_handles(data.my_axes), 'Value'); % use fixed aspect ratio
    slice    = -1; % disable slice by default
    if(get(data.psv_hnames.slice_handles(6,data.my_axes),'Value'))
        slice = get(data.psv_hnames.slice_handles(1,data.my_axes),'Value');
        if (slice == 0) % not yet set, (toggle button pressed)
            slice = round(( data.ps(data.my_axes).nbins + 1)/2);
        elseif size(data.ps(data.my_axes).slices,2) < slice
            slice = data.ps(data.my_axes).nbins;
        end
    end
    % plot phasespace
    data = psv_plot_phasespace( data, hor_axis, ver_axis, mesh, fix, slice);
end
