function data = psv_show_movie(data, workingAxes, saveavi)
        
    oldTag = get( data.psv_hnames.dir_handles(4, data.my_axes), 'Tag');
    if strcmp( oldTag, 'run')
        set( data.psv_hnames.dir_handles(4, data.my_axes), 'Tag', 'stop');
        return;
    end
    
    aviobj = [];
    if saveavi == 1
        avi_filename = get_avi_filename(data);
        if isempty(avi_filename)
            return;
        end
        aviobj = avifile(avi_filename, 'fps', 5, 'compression', 'None' );
        if workingAxes == 1
            a = data.handles.axes1;
        else
            a = data.handles.axes2;
        end
        ui = get ( data.handles.uipanel6, 'Position' );
        framepos = get( a, 'OuterPosition' );
    end
    
    set( data.psv_hnames.dir_handles(4, data.my_axes), 'Tag', 'run');    
    data.my_axes = workingAxes;
    ps_files = data.ps(data.my_axes).bl.file_names;
    fileMax  = length(ps_files);
    data.ps(data.my_axes).inMovie = 1;
    for i=1:fileMax
        data.ps(data.my_axes).bl.act_file = i;
        data = psv_set_ui_visibility(data); % update visual elements
        data = psv_get_ps(data, true ,false);
        if ~isempty(aviobj)
            frame = getframe( gcf, [ ui(1)+framepos(1) ui(2)+framepos(2) framepos(3) framepos(4) ]);
            aviobj = addframe( aviobj, frame);
        end
        pause(0.1)       
        if strcmp(get( data.psv_hnames.dir_handles(4, data.my_axes), 'Tag' ), 'stop')
            break;
        end
    end
    if ~isempty(aviobj)
        aviobj = close( aviobj ); %#ok<NASGU>
    end;
    set( data.psv_hnames.dir_handles(4, data.my_axes), 'Tag', oldTag);
end

function filename = get_avi_filename(data)
    [FileName, PathName, filterindex] = uiputfile( {'*.avi', 'Avi';'*.*','Show all'} ,'Save movie as avi', data.psv_defaults(data.my_axes).path);
    if filterindex == 0
        filename = [];
        return;
    end
    filename = strcat( PathName, FileName );
end